#!/usr/bin/perl
#############################################################
#  pcmeasure2mrtg.pl  Zugriff auf Daten der MessPC Software
#                     ber das Netzwerk und bergabe an MRTG
#
#  Version 1.2 vom 11.3.2008
#
#  (C) Lutz Schulze 2002-2008 www.messpc.de
#
#  Aufruf: pcmeasure2mrtg.pl IP-Adresse sensor1 sensor2
#
#  Die Parameter sensor1 und sensor2 bestimmen die Interfaces
#  der MessPC - Software, die ausgegeben werden sollen.
#  Beispiel: pcmeasure2mrtg.pl 10.1.1.1 lpt1.1 com1.1
#############################################################

use IO::Socket;
use Text::ParseWords;
sub parse_csv {
    return quotewords(";",0, $_[0]);
}

$remote_host = $ARGV[0]; # IP-address
$remote_port = 4000;     # TCP Port

$socket = IO::Socket::INET->new(PeerAddr =>$remote_host,
                                PeerPort =>$remote_port,
                                Proto         =>"tcp",
                                Type         =>SOCK_STREAM)
or die "cannot connect to $remote_host:$remote_port: $@\n";

print $socket "pcmeasure.$ARGV[1]\r\n";

eval {
    local $SIG{ALRM} = sub { die "alarm\n"};
    alarm 5;
    $answer = <$socket>;
    alarm 0;
};
if ($@) {
    die unless $@ eq "alarm\n"; # handle unexpected errors
    #no answer, timeout
    print "timeout";
} else {
    @fields = parse_csv($answer);
    for ($i =0;$i < @fields;$i++) {
      $pos1 =index $fields[$i],'value';
      if ($pos1  != -1) {
        $pos2 =index $fields[$i],'=';
        $valuestring1 = substr($fields[$i],$pos2+1);
    }
  }
}

close($socket);

$valuestring2 = 0;
if ($ARGV[2] ne '') {
    $socket = IO::Socket::INET->new(PeerAddr =>$remote_host,
                                    PeerPort =>$remote_port,
                                    Proto         =>"tcp",
                                    Type         =>SOCK_STREAM)
    or die "cannot connect to $remote_host:$remote_port: $@\n";
    print $socket "pcmeasure.$ARGV[2]\r\n";
  eval {
    local $SIG{ALRM} = sub { die "alarm\n"};
    alarm 5;
    $answer = <$socket>;
    alarm 0;
  };
  if ($@) {
    die unless $@ eq "alarm\n"; # handle unexpected errors
    #no answer, timeout
    print "timeout";
  }
  else {
    @fields = parse_csv($answer);
    for ($i =0;$i < @fields;$i++) {
      $pos1 =index $fields[$i],'value';
      if ($pos1  != -1) {
        $pos2 =index $fields[$i],'=';
        $valuestring2 = substr($fields[$i],$pos2+1);
      }
    }
  }
    close($socket);
}

$valuestring1 = $valuestring1 * 10; #MRTG will nur ganze Zahlen
$valuestring2 = $valuestring2 * 10;
print "$valuestring1\n$valuestring2\n0 Std\n$ARGV[0]\n";
